
function change_slideBar_value(obj, value) {
    value = (value > 1) ? 1 : (value < 0) ? 0 : value; 
    if (value >= 0.0 && value <= 1.0)
    {
        obj.find('.cur').css('left', value * 100 + '%');
        obj.find('.label.current').css('left', -value * 50 + 'px');
        var min = parseFloat(obj.data('min'));
        var max = parseFloat(obj.data('max'));
        var c_val = (min + (max - min) * value).toPrecision(3);
        obj.find('.label.current').html(c_val);
        obj.attr('value', c_val);
        obj.trigger('changed');
    }
}
$.fn.aui_val = function(val) {
    var $this = $(this).eq(0);
    if (val === undefined)
    {
        if ($this.hasClass('allonsyUI_slideBar'))
            return parseFloat($this.attr('value'));
        if ($this.hasClass('allonsyUI_switcher'))
            return parseInt($this.attr('value'));
        else return undefined;
    }
    else
    {
        if ($this.hasClass('allonsyUI_slideBar'))
        {
            var min = parseFloat($this.data('min'));
            var max = parseFloat($this.data('max'));
            change_slideBar_value($this, (val - min) / (max - min));
        }
        if ($this.hasClass('allonsyUI_switcher'))
            $this.find('.item').eq(parseInt(val)).trigger('click');
    }
};
$(function() {
    var isMouseDown = false;
    $('body').mousedown( function() {
        isMouseDown = true;
    });
    $('body').mouseup( function() {
        isMouseDown = false;
    });
    $('body').mouseleave( function() {
        isMouseDown = false;
    });
    $('.allonsyUI_slideBar').mousemove( function(e) {
        if (isMouseDown)
            change_slideBar_value($(this),(e.pageX - $(this).offset().left) / $(this).width());
    });
    $('.allonsyUI_slideBar').click( function(e) {
        change_slideBar_value($(this),(e.pageX - $(this).offset().left) / $(this).width());
    });
    $('.allonsyUI_checkBox').click( function() {
        if ($(this).attr('checked')) 
        {
            $(this).removeAttr('checked');
            $(this).trigger('unchecked');
        }
        else
        {
            $(this).attr('checked','true');
            $(this).trigger('checked');
        }
    });
    $('.allonsyUI_switcher .item').click( function() {
        var parent = $(this).parent('.allonsyUI_switcher');
        parent.attr('value',$(this).index());
        parent.children('.current').removeClass('current');
        $(this).addClass('current');
        parent.trigger('changed');
    });
    $(document).ready( function() {
        $('.allonsyUI_slideBar').each( function() {
            var min = parseFloat($(this).data('min'));
            var max = parseFloat($(this).data('max'));
            var val = $(this).aui_val();
            change_slideBar_value($(this), (val - min) / (max - min)); 
        });
    });
});