$(function () {  
// ADDITIONAL FUNCTIONS
    function get_prop_value(min, max, current) {
        return (current - min) / (max - min);
    }
    var ui_loader = $("#loader").eq(0);
    function show_loader() {
        ui_loader.show();
    }
    function hide_loader() {
        ui_loader.hide();
    }
    $(document).ready(function() {
        if(typeof(Worker) === "undefined")
            alert('Ваш браузер не поддерживает HTML 5 Web Worker. Пожалуйста, обновите браузер.')
    });
// PAGES LOGIC
    var main_page = ($('[data-page][data-page-main]').eq(0));;
    var current_page = main_page;
    var pages_switch_delay = 300;
    var disable_pages_switch = false;
    function goto_page_by_name(page_name) {
        goto_page($('[data-page="' + page_name + '"]').eq(0));
    }
    function goto_page(page) {
        if (disable_pages_switch ||
            current_page[0] == page[0]) return;
        if (page[0] != main_page[0]) $('[data-page-to-main]').fadeIn(pages_switch_delay);
        else $('[data-page-to-main]').fadeOut(pages_switch_delay);
        disable_pages_switch = true;
        current_page.trigger('page_disappear_event');
        setTimeout(function() {        
            page.trigger('page_appear_event');
            current_page = page;
            disable_pages_switch = false;
        }, pages_switch_delay);
    }
    $('[data-page]').bind('page_disappear_event', function() {
        $(this).fadeOut(pages_switch_delay);
    });
    $('[data-page]').bind('page_appear_event', function() {
        $(this).fadeIn(pages_switch_delay);
    });
    $('[data-page-link]').click(function() {
        if ($(this).is('[disabled]')) return;
        goto_page_by_name($(this).data('page-link'));
    });
    $('[data-page-to-main]').click(function() {
        goto_page(main_page);
    });
    $(document).keydown(function(eventObject) {
        if (eventObject.which == 9 /* Tab */)
            goto_page(main_page);
    });
    $(document).ready(function() {
        main_page.trigger('page_appear_event');
    });
    
// PAGE: HOME
    $('#menu_calc_btn').click(function() {
        $('#sub_calc_menu').slideToggle(pages_switch_delay);
    });
    $('[data-page="home"]').bind('page_disappear_event', function() {
        $('#sub_calc_menu').slideUp(pages_switch_delay);
    });
    
// CALCULATION
    var iad_object = new InterAndDiffr();
    var current_record_wave_length = undefined;
    var current_record_l = undefined;
    
// PAGE RECORD, RESTORE 
    $(".allonsyUI_slideBar.w_color").bind("changed", function() {
        var color = iad_object.CountColor(0.000000001 * $(this).aui_val());
        $(this).find(".pointer").css("background-color", "rgb(" + color.r + "," + color.g + "," + color.b + ")");
    });
    
// PAGE: RECORD
    var record_spreading = $('#record_spreading');
    var record_spreading_graphic = undefined;
    var record_scene = $('#record_scene');
    var record_canvas = $('#record_canvas');
    var record_context = record_canvas[0].getContext('2d');
    var record_image_size = undefined;
    var record_ui_wave_length = $('#record_wave_length').eq(0);
    var record_ui_l = $('#record_l').eq(0);
    var record_ui_b = $('#record_b').eq(0);
    var record_ui_info = $('#record_information').eq(0);
    var record_l_min = undefined;
    var record_l_max = undefined;
    var record_vis_mode = 0;
    function rotate_record_canvas() {
        var z_component = -100 * get_prop_value(record_l_min, record_l_max, record_ui_l.aui_val()) - 300;
        record_canvas.css('transform', 'perspective(' + 1100 + 'px) ' + 
            'rotate3d(0, 60, 0, 55deg) ' + 
            'translate3d(-77px, -237px, ' + z_component + 'px)');
    }
    function record_info_text(text) {
        record_ui_info.html(text);
    }
    function record_info_show() {
        record_ui_info.fadeIn(300);
    }
    function record_info_hide() {
        record_ui_info.fadeOut(300);
    }
    record_canvas.mouseenter(function(eventObject) {
        record_info_show();
    });
    record_canvas.mouseleave(function(eventObject) {
        record_info_hide();
    });
    $('#record_switcher').bind('changed', function () {
        switch (record_vis_mode = $(this).aui_val())
        {
            case 0:
                record_spreading.fadeOut(300);
                record_scene.fadeIn(300).removeClass('active');
                record_canvas.css('transform', 'perspective(0px) ' + 
                    'rotate3d(0, 0, 0, 0deg ) ' + 
                    'translate3d(-237px, -237px, 0px)');
                break;
            case 1:
                record_spreading.fadeOut(300);
                record_scene.fadeIn(300).addClass('active');
                rotate_record_canvas();
                break;
            case 2:
                record_spreading.fadeIn(300);
                record_scene.fadeOut(300);
        }
    });
    $('#record_l').bind('changed', function() {
		if (record_vis_mode != 1) return;
		rotate_record_canvas();
    });
    $('[data-page=record] .allonsyUI_slideBar').bind('changed', function() {
        record_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
		if (record_spreading_graphic !== undefined)
			record_spreading_graphic.clearObjects();
		$('[data-page-link=restore]').attr('disabled','true');
        restore_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
		if (restore_spreading_graphic !== undefined)
			restore_spreading_graphic.clearObjects();
    });
    $('#record_calculate').click(function() {
        show_loader();
        setTimeout(function() {
            var wave_length = record_ui_wave_length.aui_val();
            var l = record_ui_l.aui_val();
            var b = record_ui_b.aui_val() / 1000;
            current_record_wave_length = wave_length;
            current_record_l = l;
            wave_length *= 0.000000001;
            record_context.clearRect(0, 0, record_canvas[0].width, record_canvas[0].height);
            var max_linear_size = 0.005;
            var E_point = 2.0 * Math.sqrt(5) / Math.PI / wave_length;
            var E_Sph = E_point * Math.PI * wave_length * l * 0.1;
            var I_tau = E_Sph / E_point / l;
            var gr_n_n = 351;
            var  NonColorInt = iad_object.CalcInter(E_point, wave_length, l, I_tau, E_Sph, gr_n_n, record_canvas[0].width, record_canvas[0].height, b, max_linear_size);
            var ColoredInt = iad_object.MakeColored(NonColorInt, wave_length);
            for (var i = 0; i < record_canvas[0].width; i++)
                for (var j = 0; j < record_canvas[0].height; j++)
                {
                    record_context.fillStyle = "rgba(" +
                        ColoredInt[i][j].r+"," +
                        ColoredInt[i][j].g+"," +
                        ColoredInt[i][j].b+"," +
                        ColoredInt[i][j].a+")";
                    record_context.fillRect(i, j, 1, 1);
                }
            record_image_size = Math.round(iad_object.picture_scale * iad_object.image_size * 100000) / 100000;
            record_spreading_graphic = new Graphic("#record_spreading_gr", 0, 0.5*record_image_size/1.2, 0, 1.3, "Intensity distribution");

            var record_sc_r_points = [];
            var img_s_1_2 = parseInt(iad_object.InterferentionImage.length / 2);
            for (var i = img_s_1_2, x = 0; i < iad_object.InterferentionImage.length; i++, x++)
                record_sc_r_points.push({
                    x: x * iad_object.pixel_scale,
                    y: iad_object.InterferentionImage[img_s_1_2][i]
                });
            var f = new polyLineGraphicFunc(record_sc_r_points, "Intensity", "#fff");
            record_spreading_graphic.AddObject(f);
            record_spreading_graphic.style.axis.show_marks = false;
            record_spreading_graphic.drawAxis();

            $('[data-page-link=restore][disabled]').removeAttr('disabled');
            restore_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
			restore_int_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
            restore_is_default_changed = false;
            hide_loader();
        }, 100);
    });
    $(document).ready(function() {
        record_l_min = record_ui_l.data('min');
        record_l_max = record_ui_l.data('max');
        var color = iad_object.CountColor(0.000000001 * record_ui_wave_length.aui_val());
        record_ui_wave_length.find(".pointer").css("background-color", "rgb(" + color.r + "," + color.g + "," + color.b + ")");
    });
    
// PAGE: RESTORE
    var restore_spreading = $('#restore_spreading');
    var restore_spreading_graphic = undefined;
    var restore_scene = $('#restore_scene');
    var restore_canvas = $('#restore_canvas');
    var restore_context = restore_canvas[0].getContext('2d');
    var restore_int_canvas = $('#restore_int_canvas');
    var restore_int_context = restore_int_canvas[0].getContext('2d');
    var restore_image_size = undefined;
    var restore_ui_wave_length = $('#restore_wave_length').eq(0);
    var restore_ui_l = $('#restore_l').eq(0);
    var restore_ui_info = $('#restore_information').eq(0);
    var restore_l_min = undefined;
    var restore_l_max = undefined;
    var restore_vis_mode = 0;
    var restore_zoom_factor = 1;
    var restore_is_default_changed = false;
    function rotate_restore_canvas() {
        var z_component = -400 * get_prop_value(restore_l_min, restore_l_max, restore_ui_l.aui_val()) - 270;
        /*restore_canvas.css('transform', 'perspective(' + 1100 + 'px) ' + 
            'rotate3d(0, 60, 0, 55deg) ' + 
            'translate3d(-77px, -197px, ' + z_component + 'px)');*/
        restore_canvas.css('transform', '');
		restore_canvas.css('margin-left', -100 * get_prop_value(restore_l_min, restore_l_max, restore_ui_l.aui_val()) - 200);
    }
    function zoom_restore_canvas(zoom_factor) {
        if (zoom_factor > 1) restore_scene.find('.hide_for_zoom').fadeOut(300);
        else restore_scene.find('.hide_for_zoom').fadeIn(300);
        restore_zoom_factor = zoom_factor;
        restore_canvas.css('transform', 'perspective(0px) ' + 
                    'rotate3d(0, 0, 0, 0deg) ' + 
                    'translate3d(-237px, -207px, 0px) scale3d(' + zoom_factor + ',' + zoom_factor + ',1)');
		restore_canvas.css('margin-left', 0);
    }
    function restore_info_text(text) {
        restore_ui_info.html(text || 'undefined');
    }
    function restore_info_show() {
        restore_ui_info.fadeIn(300);
    }
    function restore_info_hide() {
        restore_ui_info.fadeOut(300);
    }
    restore_canvas.mouseenter(function(eventObject) {
        restore_info_show();
    });
    restore_canvas.mouseleave(function(eventObject) {
        restore_info_hide();
    });
    $('#restore_switcher').bind('changed', function () {
        switch (restore_vis_mode = $(this).aui_val())
        {
            case 0:
                $('#restore_zoom_switcher').fadeIn(300);
                zoom_restore_canvas(restore_zoom_factor);
                restore_spreading.fadeOut(300);
                restore_scene.fadeIn(300).removeClass('active');
                break;
            case 1:
                $('#restore_zoom_switcher').fadeOut(300);
                restore_spreading.fadeOut(300);
                restore_scene.fadeIn(300).addClass('active');
                rotate_restore_canvas();
                break;
            case 2:
                $('#restore_zoom_switcher').fadeOut(300);
                restore_spreading.fadeIn(300);
                restore_scene.fadeOut(300);
        }
    });
    $('#restore_zoom_switcher').bind('changed', function () {
        if (restore_vis_mode != 0) return;
        switch ($(this).aui_val())
        {
            case 0:
                zoom_restore_canvas(1);
                break;
            case 1:
                zoom_restore_canvas(2);
                break;
            case 2:
                zoom_restore_canvas(5);
                break;
            case 3:
                zoom_restore_canvas(10);
                break;
        }
    });
    $('#restore_l').bind('changed', function() {
		if (restore_vis_mode != 1) return;
		rotate_restore_canvas();
    });
    $('[data-page=restore] .allonsyUI_slideBar').bind('changed', function() {
        restore_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
		if (restore_spreading_graphic !== undefined)
			restore_spreading_graphic.clearObjects();
    });
    restore_ui_wave_length.bind('changed', function() {
        restore_int_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
    });
    $('#restore_calculate').click(function() {
        show_loader();
        setTimeout(function() {
            var wave_length = 0.000000001 * restore_ui_wave_length.aui_val();
            var l = restore_ui_l.aui_val();
            restore_context.clearRect(0, 0, restore_canvas[0].width, restore_canvas[0].height);
            var PixelScale = iad_object.pixel_scale;
            var max_line_size = 0.005;
            var NonColorDifr = iad_object.CalcDiffr(l, wave_length, max_line_size);
            var ColoredDifr = iad_object.MakeColored(NonColorDifr, wave_length);
            for (var i = 0; i < restore_canvas[0].width; i++)
                for (var j = 0; j < restore_canvas[0].height; j++)
                {
                    restore_context.fillStyle = "rgba(" +
                        ColoredDifr[i][j].r + "," +
                        ColoredDifr[i][j].g + "," +
                        ColoredDifr[i][j].b + "," +
                        ColoredDifr[i][j].a + ")";
                    restore_context.fillRect(i, j, 1, 1);
                }
            restore_image_size = restore_canvas[0].width * iad_object.scales/1.2;
            var ColoredInt = iad_object.MakeColored(iad_object.InterferentionImage, wave_length);
            for (var i = 0; i < restore_int_canvas[0].width; i++)
                for (var j = 0; j < restore_int_canvas[0].height; j++)
                {
                    restore_int_context.fillStyle = "rgba(" +
                        ColoredInt[i][j].r+"," +
                        ColoredInt[i][j].g+"," +
                        ColoredInt[i][j].b+"," +
                        ColoredInt[i][j].a+")";
                    restore_int_context.fillRect(i, j, 1, 1);
                }
            restore_spreading_graphic = new Graphic("#restore_spreading_gr", 0, 0.5*restore_image_size, 0, 1.3, "Intensity distribution");
			/*var sc_r_points = [];
            var img_s_1_2 = parseInt(iad_object.InterferentionImage.length / 2);
            for (var i = img_s_1_2, x = 0; i < iad_object.DiffractionImage.length; i++, x++)
                sc_r_points.push({
                    x: x * iad_object.scales,
                    y: iad_object.DiffractionImage[img_s_1_2][i]
                });*/
            var f = new polyLineGraphicFunc(iad_object.GraphicInterpolated, "Intensity", '#fff');
            restore_spreading_graphic.AddObject(f);
            restore_spreading_graphic.style.axis.show_marks = false;
            restore_spreading_graphic.drawAxis();
            hide_loader();
        },100);
    });
    $('#restore_get_deafult').click(function() {
        restore_ui_wave_length.aui_val(current_record_wave_length);
        restore_ui_l.aui_val(current_record_l);
    });
    $('[data-page=restore] .allonsyUI_slideBar').bind('changed', function() {
        restore_is_default_changed = true;
    });
    $('[data-page=restore]').bind('page_appear_event', function() {
        if(!restore_is_default_changed)
        {
            restore_ui_wave_length.aui_val(current_record_wave_length);
            restore_ui_l.aui_val(current_record_l);
        }
        //restore_int_context.drawImage(record_canvas[0], 0, 0);
    });
    $(document).ready(function() {
        restore_l_min = restore_ui_l.data('min');
        restore_l_max = restore_ui_l.data('max');
        var color = iad_object.CountColor(0.000000001 * restore_ui_wave_length.aui_val());
        restore_ui_wave_length.find(".pointer").css("background-color", "rgb(" + color.r + "," + color.g + "," + color.b + ")");
    });
    
// PAGE: EXPERIMENTAL SCHEME
    var ex_canvas_js = $('#experimental_scheme_canvas')[0];
    var ex_context = ex_canvas_js.getContext('2d');
    var ex_animation_loop = undefined;
    var EX_HOLE_X_POSITION = 200;
    var EX_HOLE_APPERTURE_R = 2;
    var EX_SCREEN_X_POSITION = ex_canvas_js.width - 200;
    var EX_RENDER_DELAY = 10;
    var EX_WAVE_DELAY = 500;
    var ex_waves_is_pause = false;
    var ex_waves_elapsed_time = undefined;
    var ex_waves_array = undefined;
    var ex_wave_color = undefined;
    
    function ex_wave() {
        this.x = 0;
        this.speed = 10;
    }
    ex_wave.prototype.draw_wave = function() {
        if (this.x > ex_canvas_js.width)
        {
            self = undefined;
            return;
        }
        var is_per_hole = this.x > EX_HOLE_X_POSITION;
        
        ex_context.beginPath();
        ex_context.moveTo(this.x, 0);
        ex_context.lineTo(this.x, ex_canvas_js.height);
        ex_context.strokeStyle = 'rgba(' + ex_wave_color.r + ',' + ex_wave_color.g + ',' + ex_wave_color.b + ',' + '1)';
        ex_context.lineWidth = (is_per_hole) ? 1 : 2;
        ex_context.stroke();
        ex_context.closePath();
        
        if (is_per_hole)
        {
            ex_context.beginPath();
            ex_context.arc(EX_HOLE_X_POSITION, ex_canvas_js.height / 2,this.x - EX_HOLE_X_POSITION, -Math.PI / 2,Math.PI / 2);
            ex_context.stroke();
            ex_context.closePath();
        }
        
        this.x  += this.speed / EX_RENDER_DELAY;
    }
    function ex_init() {
        ex_context.clearRect(0, 0, ex_canvas_js.width, ex_canvas_js.height);
        ex_waves_elapsed_time = 0;
        ex_wave_color = iad_object.CountColor(0.000000001 * $('#ex_wave_length').aui_val(), 0, 0, 0);
        ex_waves_array = [];
        ex_animation_loop = setInterval(ex_animate, EX_RENDER_DELAY);
    }
    function ex_clear() {
        ex_context.clearRect(0, 0, ex_canvas_js.width, ex_canvas_js.height);
        clearInterval(ex_animation_loop);
    }
    function draw_hole() {
        ex_context.beginPath();
        ex_context.moveTo(EX_HOLE_X_POSITION, 0);
        ex_context.lineTo(EX_HOLE_X_POSITION, ex_canvas_js.height / 2 - EX_HOLE_APPERTURE_R);
        ex_context.strokeStyle = '#fff';
        ex_context.lineWidth = 5;
        ex_context.stroke();
        ex_context.closePath();
        
        ex_context.beginPath();
        ex_context.moveTo(EX_HOLE_X_POSITION, ex_canvas_js.height / 2 + EX_HOLE_APPERTURE_R);
        ex_context.lineTo(EX_HOLE_X_POSITION, ex_canvas_js.height);
        ex_context.strokeStyle = '#fff';
        ex_context.lineWidth = 5;
        ex_context.stroke();
        ex_context.closePath();
    }
    function draw_screen() {
        ex_context.beginPath();
        ex_context.moveTo(EX_SCREEN_X_POSITION, 0);
        ex_context.lineTo(EX_SCREEN_X_POSITION, ex_canvas_js.height);
        ex_context.strokeStyle = '#fff';
        ex_context.lineWidth = 5;
        ex_context.stroke();
        ex_context.closePath();
    }
    function ex_animate() {
        if(ex_waves_is_pause) return;
        ex_context.clearRect(0, 0, ex_canvas_js.width, ex_canvas_js.height);
        if (ex_waves_elapsed_time >= EX_WAVE_DELAY)
        {
            ex_waves_array.push(new ex_wave());
            ex_waves_elapsed_time = 0;
        }
        else ex_waves_elapsed_time += EX_RENDER_DELAY;
        ex_waves_array.forEach(function(wave) {
            wave.draw_wave();
        });
        ex_context.clearRect(EX_SCREEN_X_POSITION, 0, ex_canvas_js.width - EX_SCREEN_X_POSITION, ex_canvas_js.height);
        draw_hole();
        draw_screen();
    }
    $('#ex_wave_length').bind("changed", function() {
        ex_wave_color = iad_object.CountColor(0.000000001 * $(this).aui_val(), 0, 0, 0);
    });
    $('[data-page=experimental_scheme]').bind('page_appear_event', function() {
        ex_init();
    });
    $('[data-page=experimental_scheme]').bind('page_disappear_event', function() {
        clearInterval(ex_animation_loop);
    });
    $('#ex_clear').click(function() {
        ex_clear();
        ex_waves_is_pause = false;
        $('#play_pause').children('.text').html('Stop');
        ex_init();
    });
    $('#play_pause').click(function() {
        $(this).children('.text').html((ex_waves_is_pause = !ex_waves_is_pause) ? 'Start' : 'Stop');
    });
});
